#include "ChessMaster_objects.h"
#include "ChessMaster_resources.h"

//--------------------- User code ---------------------//
extern int mainengine(char* command);

extern char res[256];

extern unsigned int Xcoord, Ycoord;
unsigned int Xoff = 111, Yoff = 7;

char last_selected_figure = 0xFF;
char error_chess_castle_figure = 0x00;
char enpass_candidate_x = -1;
char enpass_candidate_y = -1;
char enpass_flag = 0;
char last_selected_x = -1;
char last_selected_y = -1;
char last_start_x = -1;
char last_start_y = -1;

// Coding of chess figures
//    figure: 1-Pawn, 2-Rook, 3-Knight, 4-Bishop, 5-King, 6-Queen
//    color of the figure: 0-white, 1-black

const char Blank = 0x00;

const char whitePawn = 0x01;
const char whiteRook = 0x02;
const char whiteKnight = 0x03;
const char whiteBishop = 0x04;
const char whiteKing = 0x05;
const char whiteQueen = 0x06;

const char blackPawn = 0x11;
const char blackRook = 0x12;
const char blackKnight = 0x13;
const char blackBishop = 0x14;
const char blackKing = 0x15;
const char blackQueen = 0x16;

char Chess_matrix[8][8];

// Starting positions of the figures
char Start_matrix[8][8] = {
  {blackRook, blackKnight, blackBishop, blackQueen, blackKing, blackBishop, blackKnight, blackRook},
  {blackPawn, blackPawn, blackPawn, blackPawn, blackPawn, blackPawn, blackPawn, blackPawn},
  {Blank, Blank, Blank, Blank, Blank, Blank, Blank, Blank},
  {Blank, Blank, Blank, Blank, Blank, Blank, Blank, Blank},
  {Blank, Blank, Blank, Blank, Blank, Blank, Blank, Blank},
  {Blank, Blank, Blank, Blank, Blank, Blank, Blank, Blank},
  {whitePawn, whitePawn, whitePawn, whitePawn, whitePawn, whitePawn, whitePawn, whitePawn},
  {whiteRook, whiteKnight, whiteBishop, whiteQueen, whiteKing, whiteBishop, whiteKnight, whiteRook}
};

// Set the figure at the starting point
void StartTable(){
char i, j;
  for (i = 0; i < 8; i ++)
    for (j = 0; j < 8; j ++)
      Chess_matrix[i][j] = Start_matrix[i][j];
}

// Drawing the figures
void Draw_Figure(char i, char j, char figure){
unsigned int x0, y0;
const code char *ptr;

  x0 = j * 32 + Xoff;
  y0 = i * 32 + Yoff;
  switch (figure){
    case blackPawn : {
                      if (((i + j) % 2) == 0)
                        ptr = pawn_black_1_bmp;
                      else
                        ptr = pawn_black_2_bmp;
                      }; break;
    case blackRook : {
                      if (((i + j) % 2) == 0)
                        ptr = rook_black_1_bmp;
                      else
                        ptr = rook_black_2_bmp;
                      }; break;
    case blackKnight : {
                      if (((i + j) % 2) == 0)
                        ptr = knight_black_1_bmp;
                      else
                        ptr = knight_black_2_bmp;
                      }; break;
    case blackBishop : {
                      if (((i + j) % 2) == 0)
                        ptr = bishop_black_1_bmp;
                      else
                        ptr = bishop_black_2_bmp;
                      }; break;
    case blackKing : {
                      if (((i + j) % 2) == 0)
                        ptr = king_black_1_bmp;
                      else
                        ptr = king_black_2_bmp;
                      }; break;
    case blackQueen : {
                      if (((i + j) % 2) == 0)
                        ptr = queen_black_1_bmp;
                      else
                        ptr = queen_black_2_bmp;
                      }; break;
    case whitePawn : {
                      if (((i + j) % 2) == 0)
                        ptr = pawn_white_1_bmp;
                      else
                        ptr = pawn_white_2_bmp;
                      }; break;
    case whiteRook : {
                      if (((i + j) % 2) == 0)
                        ptr = rook_white_1_bmp;
                      else
                        ptr = rook_white_2_bmp;
                      }; break;
    case whiteKnight : {
                      if (((i + j) % 2) == 0)
                        ptr = knight_white_1_bmp;
                      else
                        ptr = knight_white_2_bmp;
                      }; break;
    case whiteBishop : {
                      if (((i + j) % 2) == 0)
                        ptr = bishop_white_1_bmp;
                      else
                        ptr = bishop_white_2_bmp;
                      }; break;
    case whiteKing : {
                      if (((i + j) % 2) == 0)
                        ptr = king_white_1_bmp;
                      else
                        ptr = king_white_2_bmp;
                      }; break;
    case whiteQueen : {
                      if (((i + j) % 2) == 0)
                        ptr = queen_white_1_bmp;
                      else
                        ptr = queen_white_2_bmp;
                      }; break;
    case Blank : {
                      if (((i + j) % 2) == 0)
                        ptr = blank_1_bmp;
                      else
                        ptr = blank_2_bmp;
                      }; break;
  }
  
  Chess_matrix[i][j] = figure;
  TFT_Image(x0, y0, ptr, 1);
}

// Drawing the figures
void Draw_Selected(char i, char j){
unsigned int x0, y0, x1, y1;
  x0 = j * 32 + Xoff+1;
  y0 = i * 32 + Yoff+1;
  x1 = x0 + 30;
  y1 = y0 + 30;
  TFT_Set_Pen(CL_GREEN,2);
  TFT_Set_Brush(0,0,0,0,0,0);
  TFT_Rectangle(x0,y0,x1,y1);
}

// Drawing the entire table
void Chess_Draw_Table(){
char i, j;

  for (i = 0; i < 8; i ++)
    for (j = 0; j < 8; j ++)
        Draw_Figure(i, j, Chess_matrix[i][j]);
}

typedef struct _Selected_Figure {
  unsigned int i;
  unsigned int j;
  char figure;
}  TSelected_Figure;

TSelected_Figure Selected_Figure;

// Display string on the screen
char move_str[6];
void DisplayString(TSelected_Figure *figure, unsigned int i, unsigned int j){
  char letters[] = "abcdefgh";
  char numbers[] = "12345678";
   
  move_str[0] = letters[figure->j];
  move_str[1] = numbers[7 - figure->i];
  move_str[2] = ' ';
  move_str[2] = letters[j];
  move_str[3] = numbers[7 - i];
  move_str[4] = 0;
}

// Move EnPassant
void Chees_EnPassant(char figure, unsigned int i0, unsigned int j0, unsigned int i1, unsigned int j1) {
  if ((figure & 0x0F) == whitePawn){
    if (j0 != j1){
      if (Chess_matrix[i1][j1] == Blank){
        if (i1 == 2){
          if(i1 + 1 == enpass_candidate_x, j1 == enpass_candidate_y)
            Draw_Figure(i1 + 1, j1, Blank), enpass_flag = 1;
        }
        if (i1 - 1 == enpass_candidate_x, j1 == enpass_candidate_y)
          Draw_Figure(i1 - 1, j1, Blank), enpass_flag = 1;
      }
    }
  }
}

//Move Castle
void Chess_Castle(char figure, unsigned int i0, unsigned int j0, unsigned int i1, unsigned int j1){
if ((figure & 0x0F) == whiteKing){
    if(j1 == (j0 + 2)){
      error_chess_castle_figure = Chess_matrix[i1][5];
      Draw_Figure(i1, 5, Chess_matrix[i1][7]);
      Draw_Figure(i1, 7, Blank);
    }
    if (j1 == (j0 - 2)){
      error_chess_castle_figure = Chess_matrix[i1][3];
      Draw_Figure(i1, 3, Chess_matrix[i1][0]);
      Draw_Figure(i1, 0, Blank);
    }
  }
}

void Chess_Promotion(char *figure, unsigned int i1){
  if ((*figure == whitePawn) && (i1 == 0)){
    *figure = whiteQueen;
  }
  else if ((*figure == blackPawn) && (i1 == 7)){
    *figure = blackQueen;
  }
}

// Move the figure based on string from virtual machine
void Chess_Move_Figure(unsigned int i0, unsigned int j0, unsigned int i1, unsigned int j1){
  char figure;
  
  if (last_selected_figure != 0xFF){
     Draw_Figure(last_selected_x, last_selected_y, last_selected_figure);
   }
  figure = Chess_matrix[i0][j0];

  enpass_flag = 0;
  Chees_EnPassant(figure, i0, j0, i1, j1);

  error_chess_castle_figure = 0;
  Chess_Castle(figure, i0, j0, i1, j1);

  last_start_x = i0;
  last_start_y = j0;
  last_selected_figure = figure;
  last_selected_x = i1;
  last_selected_y = j1;

  Chess_Promotion(&figure, i1);

  Draw_Figure(i0, j0, Blank);
  Draw_Figure(i1, j1,figure);
  Draw_Selected(i1,j1);
  if(!enpass_flag){
   enpass_candidate_x = -1;
   enpass_candidate_y = -1;
   if ((figure & 0x0F) == whitePawn){
      if (i1 > i0){
          if ((i1-i0) == 2){
             enpass_candidate_x = i1;
             enpass_candidate_y = j1;
          }
        } else if ((i0-i1) == 2){
           enpass_candidate_x = i1;
           enpass_candidate_y = j1;
        }
     }
  }
}
 // Read string that comes from virtual machine
void  ReadString(char *text){
  unsigned int i0, j0, i1, j1;

  j0 = text[0] - 97;
  i0 = 7 - text[1] + 49;

  j1 = text[2] - 97;
  i1 = 7 - text[3] + 49;

  Chess_Move_Figure(i0,j0,i1,j1);
}

char Chess_state = 0;        //  0 - free field
                             //  1 - figure selected
void Chess_State_Machine(unsigned int i, unsigned int j){
  switch  (Chess_state) {
    case 0 : {
               TFT_Set_Pen(Screen1.Color,0);
               TFT_Set_Brush(1,Screen1.Color,0,0,0,0);
               TFT_Rectangle(10, 20, 100, 40);
               
               if (Chess_matrix[i][j] != 0){
                 if (last_selected_figure != 0xFF){
                   Draw_Figure(last_selected_x, last_selected_y, last_selected_figure);
                 }
                 Selected_Figure.i = i;
                 Selected_Figure.j = j;
                 Selected_Figure.figure = Chess_matrix[i][j];
                 Draw_Selected(i,j);
                 Chess_state = 1;
               }
             }; break;
    case 1 : { char dest_figure;
               // Moving the figure into chosen position
               if (Selected_Figure.i == i)
                 if (Selected_Figure.j == j)
                   break;
               dest_figure = Chess_matrix[i][j];

               DisplayString(&Selected_Figure, i, j);
               Button1.Caption = move_str;
               Button1.Color = CL_WHITE;
               Button1.Font_Color = CL_BLACK;
               DrawButton(&Button1);
               //
               Chess_Move_Figure(Selected_Figure.i, Selected_Figure.j, i, j);
               mainengine(move_str);

               if (strncmp(res, "move", 4) == 0){
                 memmove(&(res[0]), &(res[5]),5);
                 ReadString(res);
                 Button1.Caption = res;
                 Button1.Color = CL_BLACK;
                 Button1.Font_Color = CL_WHITE;
                 DrawButton(&Button1);
               }
               else
               {
                 if (strncmp(res, "Illegal", 7) == 0){
                   if (error_chess_castle_figure){
                     if(j == (Selected_Figure.j + 2)){
                       Draw_Figure(i, 5, error_chess_castle_figure);
                       Draw_Figure(i, 7, (Selected_Figure.figure & 0xF0) | whiteRook);
                     }
                     else{
                       Draw_Figure(i, 3, error_chess_castle_figure);
                       Draw_Figure(i, 0,(Selected_Figure.figure & 0xF0) | whiteRook);
                     }
                   }else if (enpass_flag){
                     if(enpass_candidate_y)
                       if(enpass_candidate_y == 5)
                         Draw_Figure(enpass_candidate_x, enpass_candidate_y,whitePawn);
                       else if(enpass_candidate_y == 2)
                         Draw_Figure(enpass_candidate_x, enpass_candidate_y,blackPawn);
                   }
                   Draw_Figure(last_start_x, last_start_y, last_selected_figure);
                   Draw_Figure(i, j, dest_figure);
                   last_selected_figure = 0xff;
                   enpass_flag = 0;
                 }
                 Button1.Color = CL_RED;
                 DrawButton(&Button1);
                 TFT_Set_Font(Button1.FontName, CL_RED, FO_HORIZONTAL);
                 TFT_Write_Text(res, 10, 20);
               }

               Chess_state = 0;

             }; break;
    default : {
                Chess_state = 0;
              }; break;
  }
}

//----------------- End of User code ------------------//

// Event Handlers
void Box1OnClick() {
unsigned int x0, y0;

  y0 = (Xcoord - Xoff);
  y0 = y0 / 32;
  x0 = (Ycoord - Yoff);
  x0 = x0 / 32;
  
  Chess_State_Machine(x0, y0);
}