/*
 * Project name:
     ChessMaster.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     4/16/2013
 * Time of creation
     5:08:12 PM
 * Test configuration:
     MCU:             STM32F407ZG
     Dev.Board:       Mikromedia_Plus_for_STM32_ARM  ac:Media_plus
                      http://www.mikroe.com/mikromedia/plus/stm32-m4/
     Oscillator:      150000000 Hz
     Ext. Modules:    ac:SpeakUp
                      http://www.mikroe.com/click/speakup/
     SW:              mikroC PRO for ARM
                      http://www.mikroe.com/mikroc/arm/
 */

#include "ChessMaster_objects.h"

void StartTable();
void Chess_Draw_Table();
void ReadString(char *text);

char move[6] = "c2 c4";
char Machine_turn;
  
extern void initAI();
extern int mainengine(char* command);

char uart_cmd[4];
char uart_cmd_counter = 0;
char Send_uart_cmd = 0;
char received;

void Chess_State_Machine(unsigned int i, unsigned int j);

char odd = 1;

void uart2_interrupt() iv IVT_INT_USART2 ics ICS_AUTO {

  if (UART_Data_Ready()){

    if (!odd)
     { odd = 1; 
       UART_Read();
       return;
     }
    received = UART_Read();
    odd = 0;
    if (received < 16){
      if (uart_cmd_counter & 1)
        uart_cmd[uart_cmd_counter++] = 7 - (received  & 0x07);
      else
        uart_cmd[uart_cmd_counter++] = (received  & 0x07);
    }
    if(uart_cmd_counter == 2)
      Send_uart_cmd = 1;
    else if(uart_cmd_counter == 4)
      Send_uart_cmd = 2;

    uart_cmd_counter = uart_cmd_counter & 0x03;
  }
}

void main() {
  char draw = 1;

  UART2_Init_Advanced(115200,_UART_8_BIT_DATA,_UART_NOPARITY, _UART_ONE_STOPBIT, &_GPIO_MODULE_USART2_PD5_PA3);
  
  USART2_CR1bits.RXNEIE  = 1;        // enable uart rx interrupt
  NVIC_IntEnable(IVT_INT_USART2);

  Start_TP();
  StartTable();
  Chess_Draw_Table();
  initAI();
  mainengine("new");
  while (1) {
    Check_TP();
    if ((uart_cmd_counter == draw )){
        TFT_Set_Brush(1,CL_WHITE,0,0,0,0);
        TFT_Rectangle(30,80,50,100);
        TFT_Set_Font(Button1.FontName, CL_BLACK, FO_HORIZONTAL);
        if(uart_cmd_counter & 1)
          TFT_Write_Char('a'+received,40,80);
        else
          TFT_Write_Char('0'+received-7,40,80);
        draw =  (uart_cmd_counter+1) & 3;
    }
    
    if(Send_uart_cmd == 1)
       Chess_State_Machine(uart_cmd[1],uart_cmd[0]), Send_uart_cmd = 0;
    else if(Send_uart_cmd == 2)
      Chess_State_Machine(uart_cmd[3],uart_cmd[2]), Send_uart_cmd = 0;
    if (Machine_turn){
      ReadString(move);
    }
  }
}